Index: issm/trunk/src/c/classes/Elements/Element.cpp
===================================================================
--- issm/trunk/src/c/classes/Elements/Element.cpp	(revision 25994)
+++ issm/trunk/src/c/classes/Elements/Element.cpp	(revision 26744)
@@ -56,7 +56,120 @@
 
 	for(int i=0;i<numnodes;i++){
-		if(nodes[i]->fsize) return true;
+		if(nodes[i]->FSize()) return true;
 	}
 	return false;
+}/*}}}*/
+void       Element::AutoregressionInit(int numbasins,int arorder,int nspin,IssmDouble starttime,IssmDouble tstep_ar,IssmDouble tinit_ar,IssmDouble* beta0,IssmDouble* beta1,IssmDouble* phi,int enum_type){/*{{{*/
+
+const int numvertices = this->GetNumberOfVertices();
+   int         basinid;
+   IssmDouble  tspin,beta0_basin,beta1_basin,noisespin_basin;
+   IssmDouble* phi_basin   = xNew<IssmDouble>(arorder);
+   IssmDouble* varspin     = xNewZeroInit<IssmDouble>(numvertices*arorder);
+
+   /*Get Basin ID and Basin coefficients*/
+   if(enum_type==SMBautoregressionEnum)                   this->GetInputValue(&basinid,SmbBasinsIdEnum);
+   if(enum_type==FrontalForcingsRignotAutoregressionEnum) this->GetInputValue(&basinid,FrontalForcingsBasinIdEnum);
+   for(int i=0;i<arorder;i++) phi_basin[i] = phi[basinid*arorder+i];
+   beta0_basin   = beta0[basinid];
+   beta1_basin   = beta1[basinid];
+
+   /*Loop over number of spin-up steps for all vertices*/
+   for(int j=0;j<nspin;j++){
+      tspin = starttime-((nspin-j)*tstep_ar);
+      IssmDouble* oldvarspin = xNew<IssmDouble>(numvertices*arorder);
+      for(int i=0;i<numvertices*arorder;i++) oldvarspin[i]=varspin[i];
+
+      for(int v=0;v<numvertices;v++){
+         IssmDouble autoregressionterm = 0.;
+         for(int i=0;i<arorder;i++) autoregressionterm += phi_basin[i]*varspin[v+i*numvertices];
+         varspin[v] = beta0_basin+beta1_basin*(tspin-tinit_ar)+autoregressionterm;
+      }
+
+      /*Adjust older values in varspin*/
+      for(int i=0;i<(arorder-1)*numvertices;i++) varspin[i+numvertices]=oldvarspin[i];
+
+      xDelete<IssmDouble>(oldvarspin);
+   }
+   if(enum_type==SMBautoregressionEnum)                   this->inputs->SetArrayInput(SmbValuesAutoregressionEnum,this->lid,varspin,numvertices*arorder);
+   if(enum_type==FrontalForcingsRignotAutoregressionEnum) this->inputs->SetArrayInput(ThermalforcingValuesAutoregressionEnum,this->lid,varspin,numvertices*arorder);
+
+   /*Cleanup and return*/
+   xDelete<IssmDouble>(varspin);
+   xDelete<IssmDouble>(phi_basin);	
+}/*}}}*/
+void       Element::Autoregression(bool isstepforar,int arorder,IssmDouble telapsed_ar,IssmDouble* beta0,IssmDouble* beta1,IssmDouble* phi,bool isfieldstochastic,int enum_type){/*{{{*/
+
+   const int numvertices = this->GetNumberOfVertices();
+   int         basinid,M,N,arenum_type,basinenum_type,noiseenum_type,outenum_type;
+   IssmDouble  beta0_basin,beta1_basin,noiseterm;
+   IssmDouble* phi_basin  = xNew<IssmDouble>(arorder);
+   IssmDouble* varlist     = xNew<IssmDouble>(numvertices);
+   IssmDouble* valuesautoregression = NULL;
+   Input*      noiseterm_input      = NULL;
+
+   /*Get field-specific enums*/
+   switch(enum_type){
+      case(SMBautoregressionEnum):
+         arenum_type    = SmbValuesAutoregressionEnum;
+         basinenum_type = SmbBasinsIdEnum;
+         noiseenum_type = SmbAutoregressionNoiseEnum;
+         outenum_type   = SmbMassBalanceEnum;
+         break;
+      case(FrontalForcingsRignotAutoregressionEnum):
+         arenum_type    = ThermalforcingValuesAutoregressionEnum;
+         basinenum_type = FrontalForcingsBasinIdEnum;
+         noiseenum_type = ThermalforcingAutoregressionNoiseEnum;
+         outenum_type   = FrontalForcingsThermalForcingEnum;
+         break;
+   }
+
+   /*Get noise and autoregressive terms*/
+   this->GetInputValue(&basinid,basinenum_type);
+   if(isfieldstochastic){
+      noiseterm_input = this->GetInput(noiseenum_type);
+      Gauss* gauss = this->NewGauss();
+      noiseterm_input->GetInputValue(&noiseterm,gauss);
+      delete gauss;
+   }
+   else noiseterm = 0.0;
+   this->inputs->GetArray(arenum_type,this->lid,&valuesautoregression,&M);
+
+   /*Get basin coefficients*/
+   for(int ii=0;ii<arorder;ii++) phi_basin[ii] = phi[basinid*arorder+ii];
+   beta0_basin   = beta0[basinid];
+   beta1_basin   = beta1[basinid];
+
+	/*If not AR model timestep: take the old values of variable*/
+   if(isstepforar==false){
+      for(int i=0;i<numvertices;i++) varlist[i]=valuesautoregression[i];
+   }
+   /*If AR model timestep: compute variable values on vertices from AR*/
+   else{
+      for(int v=0;v<numvertices;v++){
+
+         /*Compute autoregressive term*/
+         IssmDouble autoregressionterm=0.;
+         for(int ii=0;ii<arorder;ii++) autoregressionterm += phi_basin[ii]*valuesautoregression[v+ii*numvertices];
+
+         /*Stochastic variable value*/
+         varlist[v] = beta0_basin+beta1_basin*telapsed_ar+autoregressionterm+noiseterm;
+      }
+      /*Update autoregression values*/
+      IssmDouble* temparray = xNew<IssmDouble>(numvertices*arorder);
+      /*Assign newest values and shift older values*/
+      for(int i=0;i<numvertices;i++) temparray[i] = varlist[i];
+      for(int i=0;i<(arorder-1)*numvertices;i++) temparray[i+numvertices] = valuesautoregression[i];
+      this->inputs->SetArrayInput(arenum_type,this->lid,temparray,numvertices*arorder);
+      xDelete<IssmDouble>(temparray);
+   }
+
+   /*Add input to element*/
+   this->AddInput(outenum_type,varlist,P1Enum);
+
+   /*Cleanup*/
+   xDelete<IssmDouble>(phi_basin);
+   xDelete<IssmDouble>(varlist);
+   xDelete<IssmDouble>(valuesautoregression);
 }/*}}}*/
 void       Element::ComputeLambdaS(){/*{{{*/
@@ -651,24 +764,20 @@
 	const int NUM_VERTICES = this->GetNumberOfVertices();
 
-	int        i;
-	IssmDouble accuref, runoffref; //reference values at given altitude
-	IssmDouble accualti, runoffalti; //reference altitudes
+	IssmDouble accuref, runoffref;  //reference values at given altitude
 	IssmDouble accugrad, runoffgrad; //gradients from reference altitude
-	IssmDouble rho_water, rho_ice;
-	IssmDouble time;
-
-	IssmDouble*		smb	 = xNew<IssmDouble>(NUM_VERTICES);
-	IssmDouble*		surf	 = xNew<IssmDouble>(NUM_VERTICES);
-	IssmDouble*		accu	 = xNew<IssmDouble>(NUM_VERTICES);
-	IssmDouble*		runoff = xNew<IssmDouble>(NUM_VERTICES);
+
+	IssmDouble smb[MAXVERTICES];
+	IssmDouble surf[MAXVERTICES];
+	IssmDouble accu[MAXVERTICES];
+	IssmDouble runoff[MAXVERTICES];
 
 	/*Get material parameters :*/
-	rho_water=this->FindParam(MaterialsRhoSeawaterEnum);
-	rho_ice=this->FindParam(MaterialsRhoIceEnum);
+	IssmDouble rho_water = this->FindParam(MaterialsRhoSeawaterEnum);
+	IssmDouble rho_ice   = this->FindParam(MaterialsRhoIceEnum);
 
 	/*Recover parameters*/
-	parameters->FindParam(&time,TimeEnum);
-	parameters->FindParam(&accualti,SmbAccualtiEnum);
-	parameters->FindParam(&runoffalti,SmbRunoffaltiEnum);
+	IssmDouble time       = this->FindParam(TimeEnum);
+	IssmDouble accualti   = this->FindParam(SmbAccualtiEnum);
+	IssmDouble runoffalti = this->FindParam(SmbRunoffaltiEnum);
 
 	/*Recover reference values at current time*/
@@ -683,7 +792,7 @@
 	/*Compute the temperature and precipitation*/
 	for(int iv=0;iv<NUM_VERTICES;iv++){
-		accu[iv]=max(0.,(accuref+(surf[iv]-accualti)*accugrad));
-		runoff[iv]=max(0.,(runoffref+(surf[iv]-runoffalti)*runoffgrad));
-		smb[iv]=(accu[iv]-runoff[iv])*rho_ice/rho_water;
+		accu[iv]   = max(0.,(accuref+(surf[iv]-accualti)*accugrad));
+		runoff[iv] = max(0.,(runoffref+(surf[iv]-runoffalti)*runoffgrad));
+		smb[iv]    = (accu[iv]-runoff[iv])*rho_ice/rho_water;
 	}
 
@@ -701,9 +810,4 @@
 	default: _error_("Not implemented yet");
 	}
-	/*clean-up*/
-	xDelete<IssmDouble>(surf);
-	xDelete<IssmDouble>(accu);
-	xDelete<IssmDouble>(runoff);
-	xDelete<IssmDouble>(smb);
 }
 /*}}}*/
@@ -825,4 +929,33 @@
 }
 /*}}}*/
+void       Element::dViscositydBMLHO(IssmDouble* pdmudB,int dim,IssmDouble* xyz_list,Gauss* gauss,Input* vxbase_input,Input* vybase_input, Input* vxshear_input ,Input* vyshear_input,Input* thickness_input,Input* n_input, IssmDouble zeta){/*{{{*/
+
+	/*Intermediaries*/
+	int materialstype;
+	IssmDouble dmudB;
+	IssmDouble epsilon[5];/* epsilon=[exx,eyy,exy,exy,exz,eyz];    */
+	IssmDouble eps_eff;
+	IssmDouble eps0=1.e-27;
+
+	/* eps_eff^2 = exx^2 + eyy^2 + exy^2 + exz^2 + eyz^2 + exx*eyy */
+   this->StrainRateMLHO(&epsilon[0],xyz_list,gauss,
+				vxbase_input,vybase_input,vxshear_input,vyshear_input,thickness_input,n_input,zeta);
+   eps_eff=sqrt(epsilon[0]*epsilon[0] + epsilon[1]*epsilon[1] + epsilon[2]*epsilon[2]
+				+ epsilon[3]*epsilon[3] + epsilon[4]*epsilon[4] + epsilon[0]*epsilon[1] + eps0*eps0);
+
+	/*Get viscosity*/
+	materialstype=this->material->ObjectEnum();
+	switch(materialstype){
+		case MaticeEnum:
+			material->GetViscosity_B(&dmudB,eps_eff,gauss);
+			break;
+		default: _error_("not supported");
+	}
+
+	/*Assign output pointer*/
+	*pdmudB=dmudB;
+
+}
+/*}}}*/
 void       Element::dViscositydBSSA(IssmDouble* pdmudB,int dim,IssmDouble* xyz_list,Gauss* gauss,Input* vx_input,Input* vy_input){/*{{{*/
 
@@ -956,5 +1089,5 @@
 	/*First, figure out size of doflist and create it: */
 	int numberofdofs=0;
-	for(int i=0;i<numnodes;i++) numberofdofs+=nodes[i]->GetNumberOfDofs(approximation_enum,setenum);
+	for(int i=0;i<numnodes;i++) numberofdofs+=nodes[i]->GetNumberOfDofs(approximation_enum,GsetEnum);
 
 	/*Allocate output*/
@@ -964,6 +1097,6 @@
 	int count=0;
 	for(int i=0;i<numnodes;i++){
-		nodes[i]->GetDofList(doflist+count,approximation_enum,setenum);
-		count+=nodes[i]->GetNumberOfDofs(approximation_enum,setenum);
+		nodes[i]->GetDofList(&doflist[count],approximation_enum,setenum);
+		count+=nodes[i]->GetNumberOfDofs(approximation_enum,GsetEnum);
 	}
 
@@ -979,5 +1112,5 @@
 	/*First, figure out size of doflist and create it: */
 	int numberofdofs=0;
-	for(int i=0;i<numnodes;i++) numberofdofs+=nodes[i]->GetNumberOfDofs(approximation_enum,setenum);
+	for(int i=0;i<numnodes;i++) numberofdofs+=nodes[i]->GetNumberOfDofs(NoneApproximationEnum,GsetEnum);
 
 	/*Allocate output*/
@@ -987,6 +1120,7 @@
 	int count=0;
 	for(int i=0;i<numnodes;i++){
+		_assert_(count<numberofdofs);
 		nodes[i]->GetDofListLocal(doflist+count,approximation_enum,setenum);
-		count+=nodes[i]->GetNumberOfDofs(approximation_enum,setenum);
+		count+=nodes[i]->GetNumberOfDofs(approximation_enum,GsetEnum);
 	}
 
@@ -1293,70 +1427,57 @@
 }
 /*}}}*/
-/* void       Element::GetVectorFromInputs(Vector<IssmDouble>* vector,int input_enum){/\*{{{*\/ */
-
-/* 	/\*Fetch number vertices for this element and allocate arrays*\/ */
-/* 	const int NUM_VERTICES = this->GetNumberOfVertices(); */
-/* 	int*        vertexpidlist = xNew<int>(NUM_VERTICES); */
-/* 	IssmDouble* values        = xNew<IssmDouble>(NUM_VERTICES); */
-
-/* 	/\*Fill in values*\/ */
-/* 	this->GetVerticesPidList(vertexpidlist); */
-/* 	this->GetInputListOnVertices(values,input_enum); */
-/* 	vector->SetValues(NUM_VERTICES,vertexpidlist,values,INS_VAL); */
-
-/* 	/\*Clean up*\/ */
-/* 	xDelete<int>(vertexpidlist); */
-/* 	xDelete<IssmDouble>(values); */
-
-/* } */
-/* /\*}}}*\/ */
 void       Element::GetVectorFromInputs(Vector<IssmDouble>* vector,int input_enum,int type){/*{{{*/
 
-	/*Fetch number vertices for this element and allocate arrays*/
-	const int NUM_VERTICES = this->GetNumberOfVertices();
-
-	int         numnodes    = this->GetNumberOfNodes();
-	int*        doflist     = NULL;
-	IssmDouble  value;
-	IssmDouble* values      = NULL;
-	Input*     input       = NULL;
-
 	switch(type){
-		case ElementSIdEnum:
-			input=this->GetInput(input_enum); _assert_(input);
+		case ElementSIdEnum:{
+         IssmDouble  value;
+			Input* input=this->GetInput(input_enum); _assert_(input);
 			input->GetInputAverage(&value);
 			vector->SetValue(this->sid,value,INS_VAL);
+                          }
 			break;
-		case VertexPIdEnum:
-			doflist = xNew<int>(NUM_VERTICES);
-			values = xNew<IssmDouble>(NUM_VERTICES);
+		case VertexPIdEnum:{
+         int        doflist[MAXVERTICES];
+         IssmDouble values[MAXVERTICES];
+			const int  NUM_VERTICES = this->GetNumberOfVertices();
 			/*Fill in values*/
-			this->GetVerticesPidList(doflist);
-			this->GetInputListOnVertices(values,input_enum);
+			this->GetVerticesPidList(&doflist[0]);
+			this->GetInputListOnVertices(&values[0],input_enum);
 			vector->SetValues(NUM_VERTICES,doflist,values,INS_VAL);
+                         }
 			break;
-		case VertexSIdEnum:
-			doflist = xNew<int>(NUM_VERTICES);
-			values = xNew<IssmDouble>(NUM_VERTICES);
+		case VertexSIdEnum:{
+         int        doflist[MAXVERTICES];
+         IssmDouble values[MAXVERTICES];
+			const int  NUM_VERTICES = this->GetNumberOfVertices();
 			/*Fill in values*/
 			this->GetVerticesSidList(doflist);
 			this->GetInputListOnVertices(values,input_enum);
 			vector->SetValues(NUM_VERTICES,doflist,values,INS_VAL);
+                         }
 			break;
-		case NodesEnum:
-			doflist = xNew<int>(numnodes);
-			values = xNew<IssmDouble>(numnodes);
+		case NodesEnum:{
+         int         numnodes = this->GetNumberOfNodes();
+         int        *doflist  = xNew<int>(numnodes);
+         IssmDouble *values   = xNew<IssmDouble>(numnodes);
 			/*Fill in values*/
 			this->GetInputListOnNodes(values,input_enum);
 			this->GetDofList(&doflist,NoneApproximationEnum,GsetEnum);
 			vector->SetValues(numnodes,doflist,values,INS_VAL);
+         xDelete<int>(doflist);
+         xDelete<IssmDouble>(values);
+                     }
 			break;
-		case NodeSIdEnum:
-			doflist = xNew<int>(numnodes);
-			values = xNew<IssmDouble>(numnodes);
+		case NodeSIdEnum:{
+         int         numnodes = this->GetNumberOfNodes();
+         int        *doflist  = xNew<int>(numnodes);
+         IssmDouble *values   = xNew<IssmDouble>(numnodes);
 			/*Fill in values*/
 			this->GetNodesSidList(doflist);
 			this->GetInputListOnNodes(values,input_enum);
 			vector->SetValues(numnodes,doflist,values,INS_VAL);
+         xDelete<int>(doflist);
+         xDelete<IssmDouble>(values);
+                       }
 			break;
 		default:
@@ -1364,44 +1485,31 @@
 	}
 
-	/*Clean up*/
-	xDelete<int>(doflist);
-	xDelete<IssmDouble>(values);
-
-}
-/*}}}*/
+}/*}}}*/
 void       Element::GetVectorFromInputs(Vector<IssmDouble>* vector,int input_enum,int type, IssmDouble time){/*{{{*/
 
-	/*Fetch number vertices for this element and allocate arrays*/
-	const int NUM_VERTICES = this->GetNumberOfVertices();
-
-	int         numnodes    = this->GetNumberOfNodes();
-	int*        doflist     = NULL;
-	IssmDouble* values      = NULL;
-
 	switch(type){
-		case VertexPIdEnum:
-			doflist = xNew<int>(NUM_VERTICES);
-			values = xNew<IssmDouble>(NUM_VERTICES);
+		case VertexPIdEnum:{
+			int        doflist[MAXVERTICES];
+			IssmDouble values[MAXVERTICES];
+			const int  NUM_VERTICES = this->GetNumberOfVertices();
 			/*Fill in values*/
 			this->GetVerticesPidList(doflist);
 			this->GetInputListOnVerticesAtTime(values,input_enum,time);
-			vector->SetValues(NUM_VERTICES,doflist,values,INS_VAL);
+			vector->SetValues(NUM_VERTICES,doflist,&values[0],INS_VAL);
+								 }
 			break;
-		case VertexSIdEnum:
-			doflist = xNew<int>(NUM_VERTICES);
-			values = xNew<IssmDouble>(NUM_VERTICES);
+		case VertexSIdEnum:{
+			int        doflist[MAXVERTICES];
+			IssmDouble values[MAXVERTICES];
+			const int  NUM_VERTICES = this->GetNumberOfVertices();
 			/*Fill in values*/
 			this->GetVerticesSidList(doflist);
 			this->GetInputListOnVerticesAtTime(values,input_enum,time);
-			vector->SetValues(NUM_VERTICES,doflist,values,INS_VAL);
+			vector->SetValues(NUM_VERTICES,doflist,&values[0],INS_VAL);
+								 }
 			break;
 		default:
 			_error_("type " << type << " (" << EnumToStringx(type) << ") not implemented yet");
 	}
-
-	/*Clean up*/
-	xDelete<int>(doflist);
-	xDelete<IssmDouble>(values);
-
 }
 /*}}}*/
@@ -1449,11 +1557,9 @@
 	/*Create list of x*/
 	const int NUM_VERTICES = this->GetNumberOfVertices();
-
-	IssmDouble* x_list = xNew<IssmDouble>(NUM_VERTICES);
-
+	IssmDouble x_list[MAXVERTICES];
 	for(int i=0;i<NUM_VERTICES;i++) x_list[i]=xyz_list[i*3+0];
-	ValueP1OnGauss(&x,x_list,gauss);
-
-	xDelete<IssmDouble>(x_list);
+
+	/*Get value at gauss point*/
+	ValueP1OnGauss(&x,&x_list[0],gauss);
 	return x;
 }/*}}}*/
@@ -1465,11 +1571,9 @@
 	/*Create list of y*/
 	const int NUM_VERTICES = this->GetNumberOfVertices();
-
-	IssmDouble* y_list      = xNew<IssmDouble>(NUM_VERTICES);
-
+	IssmDouble y_list[MAXVERTICES];
 	for(int i=0;i<NUM_VERTICES;i++) y_list[i]=xyz_list[i*3+1];
-	ValueP1OnGauss(&y,y_list,gauss);
-
-	xDelete<IssmDouble>(y_list);
+
+	/*Get value at gauss point*/
+	ValueP1OnGauss(&y,&y_list[0],gauss);
 	return y;
 }/*}}}*/
@@ -1481,11 +1585,9 @@
 	/*Create list of z*/
 	const int NUM_VERTICES = this->GetNumberOfVertices();
-
-	IssmDouble* z_list      = xNew<IssmDouble>(NUM_VERTICES);
-
+	IssmDouble z_list[MAXVERTICES];
 	for(int i=0;i<NUM_VERTICES;i++) z_list[i]=xyz_list[i*3+2];
-	ValueP1OnGauss(&z,z_list,gauss);
-
-	xDelete<IssmDouble>(z_list);
+
+	/*Get value at gauss point*/
+	ValueP1OnGauss(&z,&z_list[0],gauss);
 	return z;
 }/*}}}*/
@@ -1612,7 +1714,4 @@
 void       Element::InputCreate(IssmDouble* vector,Inputs* inputs,IoModel* iomodel,int M,int N,int vector_type,int vector_enum,int code){/*{{{*/
 
-	/*Intermediaries*/
-	int i,t;
-
 	/*Branch on type of vector: nodal or elementary: */
 	if(vector_type==1){ //nodal vector
@@ -1620,11 +1719,11 @@
 		const int NUM_VERTICES = this->GetNumberOfVertices();
 
-		int        *vertexids  = xNew<int>(NUM_VERTICES);
-		int        *vertexlids = xNew<int>(NUM_VERTICES);
-		IssmDouble *values     = xNew<IssmDouble>(NUM_VERTICES);
+		int        vertexids[MAXVERTICES];
+		int        vertexlids[MAXVERTICES];
+		IssmDouble values[MAXVERTICES];
 
 		/*Recover vertices ids needed to initialize inputs*/
 		_assert_(iomodel->elements);
-		for(i=0;i<NUM_VERTICES;i++){
+		for(int i=0;i<NUM_VERTICES;i++){
 			vertexids[i] =reCast<int>(iomodel->elements[NUM_VERTICES*this->Sid()+i]); //ids for vertices are in the elements array from Matlab
 			vertexlids[i]=iomodel->my_vertices_lids[vertexids[i]-1];
@@ -1637,5 +1736,5 @@
 		}
 		else if(M==iomodel->numberofvertices){
-			for(i=0;i<NUM_VERTICES;i++) values[i]=vector[vertexids[i]-1];
+			for(int i=0;i<NUM_VERTICES;i++) values[i]=vector[vertexids[i]-1];
 			this->SetElementInput(inputs,NUM_VERTICES,vertexlids,values,vector_enum);
 		}
@@ -1643,12 +1742,12 @@
 			/*create transient input: */
 			IssmDouble* times = xNew<IssmDouble>(N);
-			for(t=0;t<N;t++) times[t] = vector[(M-1)*N+t];
+			for(int t=0;t<N;t++) times[t] = vector[(M-1)*N+t];
 			inputs->SetTransientInput(vector_enum,times,N);
 			TransientInput* transientinput = inputs->GetTransientInput(vector_enum);
-			for(t=0;t<N;t++){
-				for(i=0;i<NUM_VERTICES;i++) values[i]=vector[N*(vertexids[i]-1)+t];
+			for(int t=0;t<N;t++){
+				for(int i=0;i<NUM_VERTICES;i++) values[i]=vector[N*(vertexids[i]-1)+t];
 				switch(this->ObjectEnum()){
-					case TriaEnum:  transientinput->AddTriaTimeInput( t,NUM_VERTICES,vertexlids,values,P1Enum); break;
-					case PentaEnum: transientinput->AddPentaTimeInput(t,NUM_VERTICES,vertexlids,values,P1Enum); break;
+					case TriaEnum:  transientinput->AddTriaTimeInput( t,NUM_VERTICES,vertexlids,&values[0],P1Enum); break;
+					case PentaEnum: transientinput->AddPentaTimeInput(t,NUM_VERTICES,vertexlids,&values[0],P1Enum); break;
 					default: _error_("Not implemented yet");
 				}
@@ -1659,23 +1758,23 @@
 
 			/*This is a Patch!*/
-			xDelete<IssmDouble>(values);
-			values = xNew<IssmDouble>(N);
-			for(int j=0;j<N;j++) values[j]=vector[this->Sid()*N+j];
+			IssmDouble* evalues = xNew<IssmDouble>(N);
+			for(int j=0;j<N;j++) evalues[j]=vector[this->Sid()*N+j];
 
 			if (N==this->GetNumberOfNodes(P1Enum)){
-				this->SetElementInput(inputs,NUM_VERTICES,vertexlids,values,vector_enum);
+				this->SetElementInput(inputs,NUM_VERTICES,vertexlids,evalues,vector_enum);
 			}
 			else if(N==this->GetNumberOfNodes(P0Enum)){
-				this->SetElementInput(inputs,vector_enum,values[0]);
+				this->SetElementInput(inputs,vector_enum,evalues[0]);
 			}
 			else if(N==this->GetNumberOfNodes(P1xP2Enum)){ _assert_(this->ObjectEnum()==PentaEnum);
-				inputs->SetPentaInput(vector_enum,P1xP2Enum,this->lid,N,values);
+				inputs->SetPentaInput(vector_enum,P1xP2Enum,this->lid,N,evalues);
 			}
 			else if(N==this->GetNumberOfNodes(P1xP3Enum)){ _assert_(this->ObjectEnum()==PentaEnum);
-				inputs->SetPentaInput(vector_enum,P1xP3Enum,this->lid,N,values);
+				inputs->SetPentaInput(vector_enum,P1xP3Enum,this->lid,N,evalues);
 			}
 			else{
 				_error_("Patch interpolation not supported yet");
 			}
+			xDelete<IssmDouble>(evalues);
 
 		}
@@ -1683,8 +1782,4 @@
 			_error_("nodal vector is either numberofvertices or numberofvertices+1 long. Field provided (" << EnumToStringx(vector_enum) << ") is " << M << " long");
 		}
-
-		xDelete<IssmDouble>(values);
-		xDelete<int>(vertexids);
-		xDelete<int>(vertexlids);
 	}
 	else if(vector_type==2){ //element vector
@@ -1708,8 +1803,8 @@
 			/*create transient input: */
 			IssmDouble* times = xNew<IssmDouble>(N);
-			for(t=0;t<N;t++) times[t] = vector[(M-1)*N+t];
+			for(int t=0;t<N;t++) times[t] = vector[(M-1)*N+t];
 			inputs->SetTransientInput(vector_enum,times,N);
 			TransientInput* transientinput = inputs->GetTransientInput(vector_enum);
-			for(t=0;t<N;t++){
+			for(int t=0;t<N;t++){
 				value=vector[N*this->Sid()+t];
 				switch(this->ObjectEnum()){
@@ -1721,4 +1816,23 @@
 			xDelete<IssmDouble>(times);
 		}
+		else if(M==1 || M==2){
+			/*create transient input: */
+			IssmDouble* times = xNew<IssmDouble>(N);
+			if(M==1)times[0]=0;
+			if(M==2)for(int t=0;t<N;t++) times[t] = vector[(M-1)*N+t];
+
+			inputs->SetTransientInput(vector_enum,times,N);
+			TransientInput* transientinput = inputs->GetTransientInput(vector_enum);
+
+			for(int t=0;t<N;t++){
+				value=vector[t]; //values are on the first line, times are on the second line
+				switch(this->ObjectEnum()){
+					case TriaEnum:  transientinput->AddTriaTimeInput( t,1,&(this->lid),&value,P0Enum); break;
+					case PentaEnum: transientinput->AddPentaTimeInput(t,1,&(this->lid),&value,P0Enum); break;
+					default: _error_("Not implemented yet");
+				}
+			}
+			xDelete<IssmDouble>(times);
+		}
 		else _error_("element vector is either numberofelements or numberofelements+1 long. Field provided (" << EnumToStringx(vector_enum) << ") is " << M << " long");
 	}
@@ -1728,5 +1842,5 @@
 		if(M==iomodel->numberofelements){
 			IssmDouble* layers = xNewZeroInit<IssmDouble>(N);
-			for(t=0;t<N;t++) layers[t] = vector[N*this->Sid()+t];
+			for(int t=0;t<N;t++) layers[t] = vector[N*this->Sid()+t];
 			inputs->SetArrayInput(vector_enum,this->lid,layers,N);
 			xDelete<IssmDouble>(layers);
@@ -1735,4 +1849,24 @@
 	}
 	else _error_("Cannot add input for vector type " << vector_type << " (not supported)");
+}
+/*}}}*/
+void       Element::InputCreateP1FromConstant(Inputs* inputs,IoModel* iomodel,IssmDouble value_in,int vector_enum){/*{{{*/
+
+	const int NUM_VERTICES = this->GetNumberOfVertices();
+
+	int        vertexids[MAXVERTICES];
+	int        vertexlids[MAXVERTICES];
+	IssmDouble values[MAXVERTICES];
+
+	/*Recover vertices ids needed to initialize inputs*/
+	_assert_(iomodel->elements);
+	for(int i=0;i<NUM_VERTICES;i++){
+		vertexids[i] =reCast<int>(iomodel->elements[NUM_VERTICES*this->Sid()+i]); //ids for vertices are in the elements array from Matlab
+		vertexlids[i]=iomodel->my_vertices_lids[vertexids[i]-1];
+	}
+
+	for(int i=0;i<NUM_VERTICES;i++) values[i]=value_in;
+	this->SetElementInput(inputs,NUM_VERTICES,vertexlids,values,vector_enum);
+
 }
 /*}}}*/
@@ -1850,7 +1984,4 @@
 	 */
 
-	/*Intermediaries*/
-	int i,t;
-
 	/*Branch on type of vector: nodal or elementary: */
 	if(vector_type==1){ //nodal vector
@@ -1858,11 +1989,11 @@
 		const int NUM_VERTICES = this->GetNumberOfVertices();
 
-		int        *vertexids  = xNew<int>(NUM_VERTICES);
-		int        *vertexlids = xNew<int>(NUM_VERTICES);
-		IssmDouble *values     = xNew<IssmDouble>(NUM_VERTICES);
+		int        vertexids[MAXVERTICES];
+		int        vertexlids[MAXVERTICES];
+		IssmDouble values[MAXVERTICES];
 
 		/*Recover vertices ids needed to initialize inputs*/
 		_assert_(iomodel->elements);
-		for(i=0;i<NUM_VERTICES;i++){
+		for(int i=0;i<NUM_VERTICES;i++){
 			vertexids[i] =reCast<int>(iomodel->elements[NUM_VERTICES*this->Sid()+i]); //ids for vertices are in the elements array from Matlab
 			vertexlids[i]=iomodel->my_vertices_lids[vertexids[i]-1];
@@ -1876,5 +2007,5 @@
 		}
 		else if(M==iomodel->numberofvertices){
-			for(i=0;i<NUM_VERTICES;i++) values[i]=vector[vertexids[i]-1];
+			for(int i=0;i<NUM_VERTICES;i++) values[i]=vector[vertexids[i]-1];
 			switch(this->ObjectEnum()){
 				case TriaEnum:  inputs->SetTriaDatasetInput(enum_type,input_id,P1Enum,NUM_VERTICES,vertexlids,values); break;
@@ -1886,8 +2017,8 @@
 			/*create transient input: */
 			IssmDouble* times = xNew<IssmDouble>(N);
-			for(t=0;t<N;t++) times[t] = vector[(M-1)*N+t];
+			for(int t=0;t<N;t++) times[t] = vector[(M-1)*N+t];
 			TransientInput* transientinput = inputs->SetDatasetTransientInput(enum_type,input_id,times,N);
-			for(t=0;t<N;t++){
-				for(i=0;i<NUM_VERTICES;i++) values[i]=vector[N*(vertexids[i]-1)+t];
+			for(int t=0;t<N;t++){
+				for(int i=0;i<NUM_VERTICES;i++) values[i]=vector[N*(vertexids[i]-1)+t];
 				switch(this->ObjectEnum()){
 					case TriaEnum:  transientinput->AddTriaTimeInput( t,NUM_VERTICES,vertexlids,values,P1Enum); break;
@@ -1901,8 +2032,4 @@
 			_error_("not implemented yet (M="<<M<<")");
 		}
-
-		xDelete<IssmDouble>(values);
-		xDelete<int>(vertexids);
-		xDelete<int>(vertexlids);
 	}
 	else if(vector_type==2){ //element vector
@@ -1983,5 +2110,5 @@
 }
 /*}}}*/
-void       Element::InputUpdateFromConstant(bool constant, int name){/*{{{*/
+void       Element::InputUpdateFromConstant(IssmDouble constant, int name, int type){/*{{{*/
 
 	/*Check that name is an element input*/
@@ -1989,4 +2116,13 @@
 
 	/*update input*/
+	this->SetElementInput(name,constant,type);
+}
+/*}}}*/
+void       Element::InputUpdateFromConstant(bool constant, int name){/*{{{*/
+
+	/*Check that name is an element input*/
+	if(!IsInputEnum(name)) return;
+
+	/*update input*/
 	this->SetBoolInput(this->inputs,name,constant);
 }
@@ -1998,5 +2134,5 @@
 	return this->isonbase;
 }/*}}}*/
-bool       Element::IsFloating(){/*{{{*/
+bool       Element::IsAllFloating(){/*{{{*/
 
 	bool shelf;
@@ -2039,5 +2175,5 @@
 bool       Element::IsIceOnlyInElement(){/*{{{*/
 	Input* input=this->GetInput(MaskIceLevelsetEnum); _assert_(input);
-	return (input->GetInputMax()<0.);
+	return (input->GetInputMax()<=0.);
 }
 /*}}}*/
@@ -2052,7 +2188,12 @@
 }
 /*}}}*/
+bool       Element::IsOceanOnlyInElement(){/*{{{*/
+	Input* input=this->GetInput(MaskOceanLevelsetEnum); _assert_(input);
+	return (input->GetInputMax()<=0.);
+}
+/*}}}*/
 void       Element::Ismip6FloatingiceMeltingRate(){/*{{{*/
 
-	if(!this->IsIceInElement() || !this->IsFloating() || !this->IsOnBase()) return;
+	if(!this->IsIceInElement() || !this->IsAllFloating() || !this->IsOnBase()) return;
 
 	int         basinid,num_basins,M,N;
@@ -2065,5 +2206,5 @@
 	/*Allocate some arrays*/
 	const int numvertices = this->GetNumberOfVertices();
-	IssmDouble* basalmeltrate = xNew<IssmDouble>(numvertices);
+	IssmDouble basalmeltrate[MAXVERTICES];
 
 	/*Get variables*/
@@ -2114,5 +2255,4 @@
 	xDelete<IssmDouble>(mean_tf);
 	xDelete<IssmDouble>(depths);
-	xDelete<IssmDouble>(basalmeltrate);
 
 }/*}}}*/
@@ -2121,9 +2261,9 @@
 	const int NUM_VERTICES = this->GetNumberOfVertices();
 
-	IssmDouble  deepwaterel,upperwaterel,deepwatermelt,upperwatermelt;
-	IssmDouble *base         = xNew<IssmDouble>(NUM_VERTICES);
-	IssmDouble *values       = xNew<IssmDouble>(NUM_VERTICES);
-	IssmDouble *perturbation = xNew<IssmDouble>(NUM_VERTICES);
-	IssmDouble 	time;
+	IssmDouble deepwaterel,upperwaterel,deepwatermelt,upperwatermelt;
+	IssmDouble base[MAXVERTICES];
+	IssmDouble values[MAXVERTICES];
+	IssmDouble perturbation[MAXVERTICES];
+	IssmDouble time;
 
 	parameters->FindParam(&time,TimeEnum);
@@ -2134,6 +2274,6 @@
 	_assert_(upperwaterel>deepwaterel);
 
-	this->GetInputListOnVertices(base,BaseEnum);
-   this->GetInputListOnVertices(perturbation,BasalforcingsPerturbationMeltingRateEnum);
+	this->GetInputListOnVertices(&base[0],BaseEnum);
+   this->GetInputListOnVertices(&perturbation[0],BasalforcingsPerturbationMeltingRateEnum);
 	for(int i=0;i<NUM_VERTICES;i++){
 		if(base[i]>=upperwaterel){
@@ -2152,7 +2292,4 @@
 
 	this->AddInput(BasalforcingsFloatingiceMeltingRateEnum,values,P1Enum);
-	xDelete<IssmDouble>(base);
-   xDelete<IssmDouble>(perturbation);
-	xDelete<IssmDouble>(values);
 
 }/*}}}*/
@@ -2161,14 +2298,14 @@
 	const int NUM_VERTICES = this->GetNumberOfVertices();
 
-	IssmDouble *deepwatermelt = xNew<IssmDouble>(NUM_VERTICES);
-	IssmDouble *deepwaterel   = xNew<IssmDouble>(NUM_VERTICES);
-	IssmDouble *upperwaterel  = xNew<IssmDouble>(NUM_VERTICES);
-	IssmDouble *base          = xNew<IssmDouble>(NUM_VERTICES);
-	IssmDouble *values        = xNew<IssmDouble>(NUM_VERTICES);
-
-	this->GetInputListOnVertices(base,BaseEnum);
-	this->GetInputListOnVertices(deepwatermelt,BasalforcingsDeepwaterMeltingRateEnum);
-	this->GetInputListOnVertices(deepwaterel,BasalforcingsDeepwaterElevationEnum);
-	this->GetInputListOnVertices(upperwaterel,BasalforcingsUpperwaterElevationEnum);
+	IssmDouble deepwatermelt[MAXVERTICES];
+	IssmDouble deepwaterel[MAXVERTICES];;
+	IssmDouble upperwaterel[MAXVERTICES];
+	IssmDouble base[MAXVERTICES];
+	IssmDouble values[MAXVERTICES];
+
+	this->GetInputListOnVertices(&base[0],BaseEnum);
+	this->GetInputListOnVertices(&deepwatermelt[0],BasalforcingsDeepwaterMeltingRateEnum);
+	this->GetInputListOnVertices(&deepwaterel[0],BasalforcingsDeepwaterElevationEnum);
+	this->GetInputListOnVertices(&upperwaterel[0],BasalforcingsUpperwaterElevationEnum);
 
 	for(int i=0;i<NUM_VERTICES;i++){
@@ -2178,11 +2315,5 @@
 	}
 
-	this->AddInput(BasalforcingsFloatingiceMeltingRateEnum,values,P1Enum);
-	xDelete<IssmDouble>(base);
-	xDelete<IssmDouble>(deepwaterel);
-	xDelete<IssmDouble>(deepwatermelt);
-	xDelete<IssmDouble>(upperwaterel);
-	xDelete<IssmDouble>(values);
-
+	this->AddInput(BasalforcingsFloatingiceMeltingRateEnum,&values[0],P1Enum);
 }/*}}}*/
 void       Element::MantlePlumeGeothermalFlux(){/*{{{*/
@@ -2193,5 +2324,5 @@
 	IssmDouble  crustheat,plumeheat,dt,middleplumedepth,a,e,eprime,A0,lambda,Alambda,dAlambda;
 	IssmDouble  x,y,z,c;
-	IssmDouble* values   = xNew<IssmDouble>(NUM_VERTICES);
+	IssmDouble  values[MAXVERTICES];
 	IssmDouble *xyz_list = NULL;
 
@@ -2228,7 +2359,6 @@
 	}
 
-	this->AddInput(BasalforcingsGeothermalfluxEnum,values,P1Enum);
+	this->AddInput(BasalforcingsGeothermalfluxEnum,&values[0],P1Enum);
 	xDelete<IssmDouble>(xyz_list);
-	xDelete<IssmDouble>(values);
 
 }/*}}}*/
@@ -2253,14 +2383,13 @@
 
 	const int  NUM_VERTICES = this->GetNumberOfVertices();
-	int        i,migration_style;
+	int        migration_style;
 	IssmDouble bed_hydro,yts;
-	IssmDouble rho_water,rho_ice,density;
-	IssmDouble* melting = xNew<IssmDouble>(NUM_VERTICES);
-	IssmDouble* phi     = xNew<IssmDouble>(NUM_VERTICES);
-	IssmDouble* h       = xNew<IssmDouble>(NUM_VERTICES);
-	IssmDouble* s       = xNew<IssmDouble>(NUM_VERTICES);
-	IssmDouble* b       = xNew<IssmDouble>(NUM_VERTICES);
-	IssmDouble* r       = xNew<IssmDouble>(NUM_VERTICES);
-	IssmDouble* sl      = xNew<IssmDouble>(NUM_VERTICES);
+	IssmDouble melting[MAXVERTICES];
+	IssmDouble phi[MAXVERTICES];
+	IssmDouble h[MAXVERTICES];
+	IssmDouble s[MAXVERTICES];
+	IssmDouble b[MAXVERTICES];
+	IssmDouble r[MAXVERTICES];
+	IssmDouble sl[MAXVERTICES];
 
 	/*Recover info at the vertices: */
